#!/usr/bin/env python

from PyQt4 import QtCore, QtGui


class MainWidget(QtGui.QMainWindow):
    def __init__(self):
        super(MainWidget, self).__init__()

        self.resize(420, 460)
        self.setWindowTitle('Board demo')

        self.board = Board(self)
        self.board.move(10, 10)
        self.board.resize(400, 400)

        self.show()


class Board(QtGui.QFrame):
    def __init__(self, parent):
        QtGui.QFrame.__init__(self, parent)

        self.board = [list(" B B B B B"),
                      list("B B B B B "),
                      list(" B B B B B"),
                      list("B B B B B "),
                      list(" B B B B B"),
                      list("B B B B B "),
                      list(" B B B B B"),
                      list("B B B B B "),
                      list(" B B B B B"),
                      list("B B B B B ")]

        self.activecell = (0, 0)

    def paintEvent(self, event):
        painter = QtGui.QPainter(self)

        for y in range(10):
            for x in range(10):
                left, top = x * 40, y * 40
                cellstate = self.board[y][x]
                color = QtGui.QColor("black")
                if cellstate == " ":
                    color = QtGui.QColor("lightgray")
                else:
                    color = QtGui.QColor(0xc2, 0xc2, 0xc2)

                if (x, y) == self.activecell:
                    color = QtGui.QColor("red")

                painter.fillRect(left, top, 40, 40, color)

    def mousePressEvent(self, event):
        if event.button() == QtCore.Qt.LeftButton:
            # convert local x and y to the board ones
            x, y = event.x() // 40, event.y() // 40

            self.activecell = (x, y)
            self.repaint()


if __name__ == "__main__":
    app = QtGui.QApplication([])
    gui = MainWidget()
    app.exec_()
